"""
/***************************************************************************
 testSelection
								 A QGIS plugin
 test plugin for QgsVectorLayer.select() bug
							  -------------------
		begin				: 2011-06-24
		copyright			: (C) 2011 by Luca
		email				: test
 ***************************************************************************/

/***************************************************************************
 *																		 *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or	 *
 *   (at your option) any later version.								   *
 *																		 *
 ***************************************************************************/
"""
# Import the PyQt and QGIS libraries
from PyQt4.QtCore import *
from PyQt4.QtGui import *
from qgis.core import *
from qgis.gui import *
# Initialize Qt resources from file resources.py
import resources
# Import the code for the dialog
from testselectiondialog import testSelectionDialog

class testSelection:
	
	emitPoint = None

	def __init__(self, iface):
		# Save reference to the QGIS interface
		self.iface = iface

	def initGui(self):
		# Create action that will start plugin configuration
		self.action = QAction(QIcon(":/plugins/testselection/icon.png"), \
			"select...", self.iface.mainWindow())
		# connect the action to the run method
		QObject.connect(self.action, SIGNAL("triggered()"), self.run)

		# Add toolbar button and menu item
		self.iface.addToolBarIcon(self.action)
		self.iface.addPluginToMenu("&select...", self.action)

	def unload(self):
		# Remove the plugin menu item and icon
		self.iface.removePluginMenu("&select...",self.action)
		self.iface.removeToolBarIcon(self.action)

	# run method that performs all the real work
	def run(self):
		QMessageBox.information (None, "", "Do these steps:\n 1. Select a layer in legend; \n 2. select a feature\n\n In QGIS 1.7 there's a bug that makes impossible to select SHP or Spatialite layers.")
		
		self.emitPoint = QgsMapToolEmitPoint(self.iface.mapCanvas())
		self.iface.mapCanvas().setMapTool(self.emitPoint)
		
		QObject.connect(self.emitPoint,
			SIGNAL("canvasClicked(const QgsPoint &, Qt::MouseButton)"),
			self.clicked)
			
	def clicked(self, pnt, but):
		vlayer = self.iface.mapCanvas().currentLayer()
		
		rect = QgsRectangle ( pnt.x() - 1, pnt.y() - 1, pnt.x() + 1, pnt.y() + 1)
		
		vlayer.select (rect, True)
		
		QMessageBox.information (None, "", "You have selected " + str (vlayer.selectedFeatureCount ()) + " features")